"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var log_1 = __importDefault(require("./log"));
var isString_1 = __importDefault(require("lodash/isString"));
var chokidar_1 = __importDefault(require("./watcher/chokidar"));
var Routes = (function () {
    function Routes(data, watcher) {
        if (watcher === void 0) { watcher = new chokidar_1["default"](); }
        if (isString_1["default"](data)) {
            this.path = path_1["default"].resolve(process.cwd(), data);
            this.readRoutes();
            watcher.init(this.path, this.onFileChange.bind(this));
            return;
        }
        this.routes = data;
    }
    Routes.prototype.readRoutes = function () {
        this.routes = JSON.parse(fs_1["default"].readFileSync(this.path).toString());
    };
    Routes.prototype.onFileChange = function () {
        log_1["default"].log(log_1["default"].blue("JSON Schema updated."));
        this.readRoutes();
    };
    return Routes;
}());
exports["default"] = Routes;
//# sourceMappingURL=routes.js.map